(function ($, Drupal) {
  Drupal.behaviors.themr_components_css_editor = {
    attach: function (context, settings) {
      setTimeout(() => {
        let editor = ace.edit('pseudo-editor');
        let edStyle = document.getElementById('pseudo-editor');
        editor.session.setMode("ace/mode/css");
        editor.setOptions({
          minLines: 15
        });
        let textarea = $('textarea[name="css"]');
        editor.getSession().setValue(textarea.val());
        editor.getSession().on('change', function () {
          textarea.val(editor.getSession().getValue());
          if (edStyle.querySelector('div.ace_gutter-cell.ace_error')) return;
          let css = editor.getSession().getValue().replaceAll("\n", "").replace(".this {", "").replace("}", "").split(";");
          let newCss = "";
          for (let row of css) {
            let cleanRow = row.trim();
            if (cleanRow) {
              newCss += cleanRow + ";";
            }
          }
          $('.themr-feature-title').attr('style', newCss);
        });
      }, 500);
    }
  }

})(jQuery, Drupal);
