(function ($, Drupal) {
  $(document).ready(function() {
    $('body').prepend('<div id="themr-overlay"></div>');
    enableChosing();

    $(window).on('dialog:afterclose', (e) => {
      enableChosing();
    });

    function enableChosing() {
      $.contextMenu({
        selector: "#themr-component-modification .themr-field",
        items: {
          visual_attributes: { name: Drupal.t("CSS Editor"), callback: loadVisualAttributes },
          animation: { name: Drupal.t("Modify Animation"), callback: loadAnimation },
          change_value: { name: Drupal.t("Change Test Value"), callback: changeValue },
          functional_attributes: { name: Drupal.t("Modify Functional Attributes"), callback: changeValue }
        }
      });
      $('#themr-component-modification .themr-field').contextMenu(true);
      $('#themr-component-modification .themr-field').on('mouseover', function () {
        $('#themr-overlay')
          .css('left', $(this).offset().left + 'px')
          .css('top', $(this).offset().top + 'px')
          .css('width', $(this).outerWidth() + 'px')
          .css('height', $(this).outerHeight() + 'px')
          .css('background-color', 'rgba(125, 0, 0, 0.15)')
          .show();
      });
      $('#themr-component-modification').on('mouseleave', function () {
        $('#themr-overlay').hide();
      });
    }

    function disableChosing() {
      $('#themr-component-modification .themr-field').off('mouseover');
      $('#themr-component-modification').on('mouseleave', function () {
        $('#themr-overlay').hide();
      });
      $('#themr-component-modification .themr-field').contextMenu(false);
    }

    function changeValue(key, opt) {
      let dialog = Drupal.ajax({
        url: '/admin/structure/themr_components/test_value/hero_component/fields/' + $(this).attr('data-themr'),
        dialogType: 'dialog',
        dialogRenderer: 'off_canvas',
      });
      dialog.execute();
      disableChosing();
    }

    function loadAnimation(key, opt) {
      let dialog = Drupal.ajax({
        url: '/admin/structure/themr_components/animations/hero_component/fields/' + $(this).attr('data-themr'),
        dialogType: 'dialog',
        dialogRenderer: 'off_canvas',
      });
      dialog.execute();
      disableChosing();
    }

    function loadVisualAttributes(key, opt) {
      let dialog = Drupal.ajax({
        url: '/admin/structure/themr_components/css_editor/hero_component/fields/' + $(this).attr('data-themr'),
        dialogType: 'dialog',
        dialogRenderer: 'off_canvas',
      });
      dialog.execute();
      disableChosing();
    }
  });
})(jQuery, Drupal);
