<?php

namespace Drupal\themr_components\Controller;

use Drupal\Core\Controller\ControllerBase;
use Symfony\Component\HttpFoundation\Response;

/**
 * Outputs the CSS.
 */
class ComponentCssRenderer extends ControllerBase {

  /**
   * Output the CSS.
   */
  public function flush($component = NULL) {
    $data = $this->config('themr_components.component.' . $component)->get('config');
    $css = "";
    $this->generateCss($data, '.paragraph--type--' . str_replace('_', '-', $component), $css);

    $response = new Response($css);
    $response->headers->set('Content-Type', 'text/css');
    return $response;
  }

  /**
   * Generate the CSS.
   */
  public function generateCss($config, $parents, &$css) {
    foreach ($config as $part) {
      $newParent = $parents;
      if (!empty($part['css']) && !empty($part['attributes']['class'])) {
        $newParent .= ' .' . str_replace(' ', '.', $part['attributes']['class']);
        $css .= $newParent . " {\n";
        foreach ($part['css'] as $key => $val) {
          $css .= "  $key: $val;\n";
        }
        $css .= "}\n\n";
      }
      if (isset($part['contains'])) {
        $this->generateCss($part['contains'], $newParent, $css);
      }
    }
  }
}
