<?php

namespace Drupal\themr_components\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\Core\Url;
use Drupal\Core\Link;

/**
 * Lists the components for modification.
 */
class ComponentsListing extends ControllerBase {

  /**
   * Lists all components.
   */
  public function list() {
    $list = $this->config('themr_components.list')->get('list');
    $rows = [];
    $response = [
      '#markup' => $this->t('No components found, create your first one.'),
    ];
    if (is_array($list)) {
      foreach ($list as $key => $name) {
        $url = Url::fromRoute('themr_components.modify', array('component' => $key));
        $link = Link::fromTextAndUrl($this->t('Edit'), $url);
        $rows[] = [
          ['data' => $name],
          ['data' => $link->toRenderable()]
        ];
      }
      $response = [
        '#theme' => 'table',
        '#header' => [
          ['data' => $this->t('Name')],
          ['data' => $this->t('Edit')],
        ],
        '#rows' => $rows,
      ];
    }

    return $response;
  }
}
